/*
 * Factorial and integer square root functions in Java.
 *
 * The functionality of all this should be verified by someone who knows Java.
 */
public class MathTools
{
	public static double fact(double x)
	{
		return fact((int) x);
	}

	public static double fact(int x)
	{
		double ret = 0.0;
		
		if (x >= 0 )
		{
			for (ret=1.0; x>1; ret=ret*x--)
				;
		}
		return ret;
	}


// This integer square root function isqrt() is untested, does not check for overflow,
// and should be changed to trap arguments less than 0.

	private static int next(int n, int i) {
		return (n + i/n) >> 1;
	}

	public static int isqrt(int number) {
		int n = 1;
		int n1 = next(n, number);

		while (Math.abs(n1 - n) > 1) {
			n = n1;
			n1 = next(n, number);
		}
		while ((n1*n1) > number) {
			n1 -= 1;
		}
		return n1;
	}
}
