# The following code should always work correctly with integers,
# because integers don't overflow in Python.
# Accepts type int or long, returns type int or long.

def isqrt(n):
    "Compute the truncated square root of any positive integer."
    if n < 0:
	raise ValueError("domain error")
	return
    xn = 1
    xn1 = (xn + n/xn)/2
    while abs(xn1 - xn) > 1:
        xn = xn1
        xn1 = (xn + n/xn)/2
    while xn1*xn1 > n:
        xn1 -= 1
    if (xn1+1)*(xn1+1) <= n:
        print "failure of isqrt()"
    return xn1
